void keyPressed(){
  
  if(key == '1'){ showAxis = !showAxis; }
  
  if(key == '2'){ showGUI = !showGUI; }
  
  if(key == '3'){ invertColors = !invertColors; }
  
  if(key == '4'){ showHelpMenu = !showHelpMenu; }
}

void draw_axis(boolean showAxis_){
  if(showAxis_){
    pushMatrix();
      translate(0,0,0); // reset to origin
      stroke(0, 0, 0);
      strokeWeight(0.5);
      line(-maxDist, 0, 0, maxDist, 0, 0);
      line(0, -maxDist, 0, 0, maxDist, 0);
      line(0, 0, -maxDist, 0, 0, maxDist);
    popMatrix();
    
    // Yes this can be done more elegeanty. 
    // But it's due in 10 hours.
    fill(0);
    pushMatrix();
      translateRotate(-maxDist, 0, 0);
      text("PC1", 0, 0, 0);
    popMatrix();
    pushMatrix();
      translateRotate(maxDist, 0, 0);
      text("PC1", 0, 0, 0);
    popMatrix();
    pushMatrix();
      translateRotate(0, maxDist, 0);
      text("PC2", 0, 0, 0);
    popMatrix();
    pushMatrix();
      translateRotate(0, -maxDist, 0);
      text("PC2", 0, 0, 0);
    popMatrix();
    pushMatrix();
      translateRotate(0, 0, maxDist);
      text("PC3", 0, 0, 0);
    popMatrix();
    pushMatrix();
      translateRotate(0, 0, -maxDist);
      text("PC3", 0, 0, 0);
    popMatrix();  
  }
  
}

String textValue;
String selectedValue;

void GUI(boolean showGUI){
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  
  if(showGUI){
    if(searchNow){
      println("Collecting text");
      searchNow = !searchNow;
      selectedTitles.clear();
      textValue = cp5.get(Textfield.class, "input").getText();
      for(String title : titleMap.keySet()){
        if(match(title.toLowerCase(), textValue.toLowerCase()) != null && !cp5.get(Textfield.class, "input").getText().equals("")){
          selectedTitles.add(title);
        }
      }
      cp5.get(ScrollableList.class, "dropdown").setItems(selectedTitles);
      cp5.get(ScrollableList.class, "dropdown").show();
      
    }else if(cp5.get(Textfield.class, "input").getText().equals("")){
      selectedTitles.clear();
      cp5.get(ScrollableList.class, "dropdown").hide();
    }
    
    if(selectedTitles.size() > 0){
      drawlines();
    }
    
    hint(DISABLE_DEPTH_TEST);
    noLights();
    cam.beginHUD();
      cp5.draw();
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
  }
}

public void submit(int theValue){
  println("Search button pressed.");
  searchNow = true;
}

public void help(){
  println("Help putton pressed.");
  showHelpMenu = !showHelpMenu;
}

void drawlines(){
  selectedValue = titleMap.get(selectedTitles.get((int)cp5.get(ScrollableList.class, "dropdown").getValue())).title;

  Edge edge = edgeMap.get(selectedValue);
  println(edge.child);
  //println(edge.parent);
  edge.drawLine();
  while(match(edge.parent.toLowerCase(), "philosophy") == null){
    edge = edgeMap.get(edge.parent);
    edge.drawLine();
    println(edge.parent);
  }
}

void checkArticles(){
  for(Article anArticle : titleMap.values()){
    if(checkboxLevel.getArrayValue()[anArticle.level] == 1){
      if(selectedTitles.size() > 0){ // user selected some titles
        if(selectedTitles.contains(anArticle.title)){
          anArticle.display(255);
          anArticle.visible = true;
        }
        else{
          anArticle.display(10.0);
          anArticle.visible = false;
        }
      }else{
        anArticle.display(255);
        anArticle.visible = true;
      }
    } else{
      anArticle.visible = false;
    }
  }
}

public static <T> boolean contains(final T[] array, final T v) {
    if (v == null) {
        for (final T e : array)
            if (e == null)
                return true;
    } else {
        for (final T e : array)
            if (e == v || v.equals(e))
                return true;
    }

    return false;
}

public void hoverLabel(){
  float minDist = MAX_FLOAT;
  Article toPrint = new Article();
  float[] coord;
  float mouseObjectDistance;
  
  for(Article article: titleMap.values()){
    coord = article.prComps;
    pushMatrix();
      translate(coord[0], coord[1], coord[2]);
      mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
      if(mouseObjectDistance < minDist && mouseObjectDistance < 20){
        minDist = mouseObjectDistance;
        toPrint = article;
      }
    popMatrix();
  }
  if(toPrint.visible){ toPrint.writeTitle(); }
}

public void translateRotate(float X, float Y, float Z){
  translate(X, Y, Z);
  rotateX(cam.getRotations()[0]);
  rotateY(cam.getRotations()[1]);
  rotateZ(cam.getRotations()[2]);
}

public void helpMenu(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
    textMode(SHAPE);
    // Background grey
    fill(color(30,30,30, 240));
    rect(0,0, width, height);
    
    // Title, subtitle
    fill(color(360));
    textAlign(CENTER);
    textSize(85);
    text("WikiGraph", width/2, height/5);
    textSize(30);
    text("A visualization of Wikipedia articles", width/2, height/5 + 50);
    float step = 27;
    textAlign(LEFT);
    textSize(25);
    text("This is an interactive 3D visualization representing a sample of roughly 16,000 articles ", 40, height/3 + step);
    text("from Wikipedia. The articles were collected using a lightweight, Python web crawler. The ", 40, height/3 + step*2);
    text("X, Y, and Z coordinates were determined from the first, second and third Principle       ", 40, height/3 + step*3);
    text("Components of the articles' text. Color and size were chosen by the remaining components.", 40, height/3 + step * 4);
    
    text("Click and drag your mouse to rotate the camera around the space. Holding the control key ", 40, height/3 + step * 6);
    text("will pan your camera. Use the numbered buttons at the top to subset the layers of        ", 40, height/3 + step * 7);
    text("Wikipedia (Philosophy is at layer 0). Use the search bar to find a specific article and  ", 40, height/3 + step * 8);
    text("see how it leads back to Philosophy. Have fun!                                           ", 40, height/3 + step * 9);
    
    text("Some articles with particularly long and interesting paths include \"The Washington      ", 40, height/3 + step * 11);
    text("Redskins Name Controversy\", \"Rape\", and \"Software Design\". Also, try searching      ", 40, height/3 + step * 12);
    text("\"Upanishads\" and pay close attention to the surrounding articles.                      ", 40, height/3 + step * 13);
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}